<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 22.11.01 - Build 25.11.2022
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
error_reporting(-1);
define('WADE_VERSION_STRING','22.11.01');
	if ( version_compare(PHP_VERSION,'5.0.0','<') )
	trigger_error('"WADE" benötigt mindestens PHP-Version 5',E_USER_ERROR);
	if ( !extension_loaded('pcre') )
	trigger_error('"WADE" benötigt Perl-kompatible reguläre Ausdrücke (PCRE)',E_USER_ERROR);
	if ( !isset($argc) || !isset($argv) )
	trigger_error('"WADE" läuft nur auf einer Kommandozeile/Shell/Eingabeaufforderung (CLI)',E_USER_ERROR);
$locale = setlocale(LC_TIME,'de_DE.utf8','de_DE.utf-8','de_DE','de','');
date_default_timezone_set('Europe/Berlin');
define('WADE_ROOT_PATH',dirname(__FILE__));
require_once('./wade.konfiguration.php');
require_once('./wade.funktionen.php');

	if ( is_array($argv) && ( !in_array('-q',$argv,true) && !in_array('--quiet',$argv,true) ) ){
	echo "**********************************************************\n";
	echo "**   W E T T E R - A N A L Y S E   I N   D E K A D E N  **\n";
	echo "**********************************************************\n";
	echo "** Berechnung der Dekadenwerte von Wetterstationen      **\n";
	echo "**     Vergleichen von Jahren zu Referenzzeiträumen     **\n";
	echo "**        Ermittlung von Rekorden in Referenzzeiträumen **\n";
	echo "**           Erstellen von Hitlisten ausgewählter Jahre **\n";
	echo "**------------------------------------------------------**\n";
	echo "** ## Von 'Trixi aus Witten/NRW'                     ## **\n";
	echo "** ## http://taw-wade.kilu.de/                       ## **\n";
	echo "**********************************************************\n";
	echo "\n";
	}

	if ( $argc < 2 || in_array(strtolower($argv[1]),array('-h','--help','-help','/h','/help','/?'),true) ){
	$php_pfad = ( isset($_SERVER['_']) ) ? realpath($_SERVER['_']) : 'Unbekannt oder CGI';
	echo "PHP-Programm: ".$php_pfad." (Version ".PHP_VERSION."/".PHP_OS.")\n";
	echo "WADE-Version: ".WADE_VERSION_STRING."\n";
	echo "Aktueller WADE-Pfad: ".WADE_ROOT_PATH."\n";
	echo "Sprache: ".$locale."\n";
	echo "Zwischenspeicher: ".$einstellungen['zwischenspeicher']['speicher_pfad']."\n\n";
	echo "Folgende Aktionen kann 'WADE' ausführen:\n";
	$module = array();
	$dateien = scandir('.');
	sort($dateien);
		foreach ( $dateien as $datei ){
			if ( preg_match('/^wade\.aktion\.\w+\.php$/iuD',$datei) ){
			$datei = file_get_contents('./'.$datei);
			preg_match('/^\/\/ @module ([a-z]+) "([^"]+)"$/ium',$datei,$modul);
				if ( is_array($modul) && sizeof($modul) === 3 ){
				echo '--'.$modul[1].str_replace(array('\t','\n'),array(chr(9),chr(10)),$modul[2]);
				$module[] = $modul[1];
				}
			}
		}
	echo "--help\t\t\tDiese zauberhaften Hilfe-Anweisungen\n";
	echo "-d\t\t\tAktualisierungspaket herunterladen (nur update)\n";
	echo "-i\t\t\tAktualisierungspaket installieren (nur update)\n";
	echo "-q\t\t\tBesonders leise sein und nichts außer Fehler ausgeben\n";
	echo "-v\t\t\tErhöht die Redseligkeit. Je häufiger 'v' angegeben wird,\n";
	echo "\t\t\tdesto geschwätziger werde ich ;)\n";
	echo "-o\t\t\tGibt den fertigen Report direkt aus und nicht in einer Datei\n\n";
	echo "Folgende Argumente können oder müssen angegeben werden:\n";
	echo "--konfiguration=[datei]\tPfad zur benutzerdefinierten Konfiguration\n";
	echo "\t\t\tStandardmäßig die 'benutzer_konfiguration.ini' im aktuellen WADE-Pfad\n";
	echo "--station=[name]\tDer Name der Station\n";
	echo "--jahr=[name]\t\tDas zu verwendene Jahr für die Grafik ".WADE_Nur_Verfuegbare_Module($module,'grafik')."\n";
	echo "--vergleich=[jahre]\tDie Jahre für den Vergleichszeitraum ".WADE_Nur_Verfuegbare_Module($module,'export,grafik,wieselflink,rekorde,hitliste,strasse')."\n";
	echo "\t\t\t\tMehrere Jahre mit Komma trennen oder eine Spanne mit - angeben\n";
	echo "\t\t\t\tDas Sternchen '*' wählt alle für die Station verfügbaren Jahre\n";
	echo "\t\t\t\tBeispiele: 1920-1980 2000,2001,2002 1980-1985,1990-1995,1997\n";
	echo "--typ=[typ]\t\tDer Ausgabetyp eines Reports ".WADE_Nur_Verfuegbare_Module($module,'export,wieselflink,rekorde,hitliste,strasse')."\n";
	echo "\t\t\t\to 'text' => Als einfache Textdatei (standard)\n";
	echo "\t\t\t\to 'csv' => CSV-Format bsp. für Excel ".WADE_Nur_Verfuegbare_Module($module,'export')."\n";
	echo "\t\t\t\to 'html' => Als HTML-Datei für das Internet\n";
	echo "\t\t\t\to 'xml' => Als XML-Datei zum Datenaustausch\n";
	echo "--typ=[typ]\t\tDie Datenbasis des Diagramms ".WADE_Nur_Verfuegbare_Module($module,'grafik')."\n";
	echo "\t\t\t\to 'abweichung' => Abweichungen vom Klimamittel (Standard)\n";
	echo "\t\t\t\to 'mittel' => Die Klimamittelwerte des Vergleichzeitraums\n";
	echo "\t\t\t\to 'absolut' => Die absoluten Werte des gewählten Jahres\n";
	echo "--bedingung=[...]\tFormuliert die Bedingung ".WADE_Nur_Verfuegbare_Module($module,'wieselflink,strasse')."\n";
	echo "\t\t\t\tBeispiele: 'temperatur_max >= 25', 'niederschlag > 0'\n";
	}
unset($dateien,$datei,$modul,$module,$locale,$php_pfad);

$DA = new Dekaden_Analyse();
$DA->KonsolenAusgabe(print_r($DA->cli_parameter,true),3);
	if ( isset($DA->cli_parameter['aktion']) && strlen($DA->cli_parameter['aktion']) > 0 && is_file('./wade.aktion.'.$DA->cli_parameter['aktion'].'.php') )
	require_once('./wade.aktion.'.$DA->cli_parameter['aktion'].'.php');
?>
